<?php

require_once('/usr/fallback/beroConf.php');
require_once('/usr/local/www/berogui/misc/database.php');
require_once('/usr/local/www/berogui/includes/Helper/Helper.php');

class apiCall {

	private $_name, $_parameters, $_files, $_execResult, $_execResultString, $_execResponseCode;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = basename(dirname(__FILE__));
		$this->_parameters = array_merge($get, $post);
		$this->_files = $files;
		$this->_execResult = true;
		$this->_execResponseCode = 200;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!isset($this->_parameters['CloudUser']) || !isset($this->_parameters['CloudPassword'])) {
			$this->_execResultString = 'error:credentials_missing;';
			$this->_execResult = false;
			$this->_execResponseCode = 406;
			return($this->_execResult);
		}

		// open databases
		$bc = new beroConf('root');
		$ba = new beroAri();

		// compile data
		$data = array('serial' => trim(Helper::getSerial(), 'cloud_username' => $this->_parameters['CloudUser'], 'cloud_password' => $this->_parameters['CloudPassword']);

		// set options for cURL
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://' . $ba->get('cloudAddress') . '/index.php?r=api/register');
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

		// run cURL
		$result = curl_exec($ch);
		curl_close($ch);

		// evaluate result
		preg_match('/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/', $result, $matches);
		$key = unserialize($matches['key']);
		if (!isset($key['key'])) {
			$this->_execResultString = 'error:' . trim($result) . ';';
			$this->_execResult = false;
			$this->_execResponseCode = 502;
			return($this->_execResult);
		}

		// save key in rootDB
		$bc->set('root', 'cloud_key', $key['key']);
		Helper::activate(1);

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}

	function responsecode () {
		return($this->_execResponseCode);
	}
}
?>
